#pset5: Magic Harp

# common import
import sys
sys.path.append('..')

from common.core import *
from common.gfxutil import *
from common.leaputil import *
from common.audio import *
from common.synth import *
from common.clock import *

from kivy.graphics import Color, Line
from kivy.graphics.instructions import InstructionGroup
from kivy.clock import Clock as kivyClock

import numpy as np



# This class displays a single string on screen. It knows how to draw the
# string and how to bend it, and animate it
class String(InstructionGroup):
    def __init__(self, ):
        super(String, self).__init__()

    # if the string is going to animate (say, when it is plucked), on_update is
    # necessary
    def on_update(self, dt):
        pass


# This class monitors the location of the hand and determines if a pluck of
# the string happened. Each PluckGesture is associated with a string (one-to-one
# correspondence). The PluckGesture also controls controls the movement of the
# String it is connected to (to show the string bending)
class PluckGesture(object):
    def __init__(self, string, idx, callback):
        super(PluckGesture, self).__init__()

    def set_hand_pos(self, pos):
        pass


# The Harp class combines the above classes into a fully working harp. It
# instantiates the strings and pluck gestures as well as a hand cursor display
class Harp(InstructionGroup):
    def __init__(self):
        super(Harp, self).__init__()

    # set the hand position as a 3D vector ranging from [0,0,0] to [1,1,1]
    def set_hand_pos(self, pos):
        pass

    # callback to be called from a PluckGesture when a pluck happens
    def on_pluck(self, idx):
        print 'pluck:', idx

    # this might be needed if Harp's internal objects need on_update()
    def on_update(self):
        pass


class MainWidget(BaseWidget) :
    def __init__(self):
        super(MainWidget, self).__init__()

        self.info = topleft_label()
        self.add_widget(self.info)

        self.leap = Leap.Controller()

        self.harp = Harp()
        self.canvas.add(self.harp)

    def on_update(self) :
        leap_frame = self.leap.frame()
        pt = leap_one_palm(leap_frame)

        norm_pt = pt # TODO convert pt (in millimeters) to unit-based coordinates

        self.harp.set_hand_pos(norm_pt)
        self.harp.on_update()

        self.info.text = leap_info(self.leap)
        self.info.text += 'x:%d\ny:%d\nz:%d\n' % (pt[0], pt[1], pt[2])


# pass in which MainWidget to run as a command-line arg
run(MainWidget)
